package com.bank;

import org.springframework.test.AbstractTransactionalDataSourceSpringContextTests;

public class AccountServiceTestIntegrated extends AbstractTransactionalDataSourceSpringContextTests implements TransactionHelper
{
    private AccountService _accountService;
    private TestForAccountService _testForAccountService;

    protected String[] getConfigLocations()
    {
        return new String[] {"applicationcontext.xml"};
    }

    public void testGetAccount()
    {
        _testForAccountService.testGetAccount();
    }

    public void testTransferFund()
    {
        _testForAccountService.testTransferFund();
    }

    public void testTransferMoreThanBalance()
    {
        _testForAccountService.testTransferMoreThanBalance();
    }

    public void testTransferOverMinimumBalance()
    {
        _testForAccountService.testTransferOverMinimumBalance();
    }

    protected void onSetUpBeforeTransaction() throws Exception
    {
        _testForAccountService = new TestForAccountService(_accountService, this);
    }

    public void setAccountService(AccountService accountService)
    {
        _accountService = accountService;
    }

    public void rollbackTransaction()
    {
        setComplete();

        try
        {
            endTransaction();
            fail("Expected exception since we can't commit transaction");
        }
        catch(Exception ex)
        {
            // OK, can't commit transaction since it has been set to rollback due to Runtime Exception thrown
        }
    }
}
